/*
								+----------------------------------+
								|                                  |
								| ***   Multi-platform timer   *** |
								|                                  |
								|   Copyright  -tHE SWINe- 2006   |
								|                                  |
								|             Timer.h              |
								|                                  |
								+----------------------------------+
*/

#ifdef WIN32
#include <windows.h>
#else
#include <time.h>
#endif
#include "Timer.h"

#ifdef WIN32

CTimer::CTimer()
{
	QueryPerformanceFrequency(&m_n_freq);
	m_n_time = -1;
}

void CTimer::ResetTimer()
{
	m_f_time = 0;
	LARGE_INTEGER n_cur_time;
	QueryPerformanceCounter(&n_cur_time);
	m_n_time = n_cur_time.QuadPart;
}

float CTimer::f_Time()
{
	LARGE_INTEGER n_cur_time;

	QueryPerformanceCounter(&n_cur_time);
	if(m_n_time == -1)
		m_f_time = 0;
	else
		m_f_time += (float)((signed)(n_cur_time.QuadPart - m_n_time)) / m_n_freq.QuadPart;
	m_n_time = n_cur_time.QuadPart;

	return m_f_time;
}

#else

CTimer::CTimer()
{
	m_n_freq = CLOCKS_PER_SEC;
	m_n_time = -1;
}

void CTimer::ResetTimer()
{
	m_f_time = 0;
	m_n_time = clock();
}

float CTimer::f_Time()
{
	unsigned long n_cur_time;

	n_cur_time = clock();
	if(m_n_time == -1)
		m_f_time = 0;
	else
		m_f_time += (float)((signed)(n_cur_time - m_n_time)) / m_n_freq;
	m_n_time = n_cur_time;

	return m_f_time;
}

#endif
